<template>
  <div class="cookie-shop-img">
    <h1>Hi! This is the cookie shopeee pe pe</h1>
    <h2>Select coockie base</h2>
    <button
      class="select-btn"
      @click="chooseBase(cookie)"
      v-for="cookie in cookieBases"
      :disabled="cookie.isSelected ? true : false"
      :key="cookie.name"
    >
      {{ cookie.name }} - for {{ cookie.price }}$
    </button>
    <h2>Select cookie addons</h2>
    <button
      class="select-btn"
      @click="chooseAddon(addon)"
      v-for="addon in cookieAddons"
      :key="addon.name"
    >
      {{ addon.name }} - for {{ addon.price }}$
    </button>
    <div class="preview">
      <cookie-preview></cookie-preview>
      <shopping-cart></shopping-cart>
    </div>
    <button @click="handleLogOut()" class="select-btn log-out">Log out</button>
  </div>
</template>

<script>
// @ is an alias to /src
// eyJhbGciOiJSUzI1NiIsInR5cCIgOiAiSldUIiwia2lkIiA6ICJmQjJpYWhDdVU4b0RkeXdsZmc4bUk2amo0dFRYVmhZcVZBLTNsTk81NVZBIn0
import CookiePreview from "@/components/CookiePreview.vue";
import ShoppingCart from "@/components/ShoppingCart.vue";

export default {
  mounted() {
    this.$store.commit("IfCookieBaseFromCookieBrowser");
    this.$store.commit("IfCookieAddonsFromCookieBrowser");
    // console.log("cookie bases ze stora: ", this.cookieBases);
  },
  name: "CookieShop",
  components: {
    CookiePreview,
    ShoppingCart,
  },
  data() {
    return {};
  },
  methods: {
    chooseBase(cookieBase) {
      // console.log("e: ", e);
      // console.log("cookieBase: ", cookieBase);
      this.$store.commit("enabledAllBases");
      this.$store.commit("newCookieBase", cookieBase);
      this.$store.commit("savedCookieBaseInBrowser", cookieBase);
    },
    chooseAddon(cookieAddon) {
      console.log("cookieAddon: ", cookieAddon);
      this.$store.commit("toggleCookieAddon", cookieAddon);
      this.$store.commit("savedCookieAddonsInBrowser");
    },

    handleLogOut() {
      const KEYCLOAK = "cookie-keycloak.mac.pl:8082";
      const MY_REALM = "test";
      const ENCODED_REDIRECT_URI = "https://cookie-maker.mac.pl:8080";
      window.location.replace(
        `https://${KEYCLOAK}/auth/realms/${MY_REALM}/protocol/openid-connect/logout?redirect_uri=${ENCODED_REDIRECT_URI}`
      );
    },
  },
  computed: {
    cookieBases() {
      return this.$store.getters.getCookieBases;
    },
    cookieAddons() {
      return this.$store.getters.getCookieAddons;
    },
  },
};
</script>

<style scoped>
.cookie-shop-img {
  margin: 0;
  padding-top: 1px;
  text-align: center;
}
.select-btn {
  background: #b0a797;
  color: black;
  text-decoration: none;
  padding: 5px;
  border: 1px solid #463412;
  font-weight: bold;
  margin: 3px;
  border-radius: 3px;
  display: inline-block;
  transition: all 0.3s;
  cursor: pointer;
}
.select-btn:hover {
  color: white;
  background: #000;
}
.select-btn:disabled {
  cursor: default;
  background: #ccc;
  color: #333;
}
.select-btn:disabled:hover {
  background: #ccc;
  color: #333;
}
.log-out {
  position: absolute;
  top: 20px;
  right: 20px;
}
.preview {
  display: flex;
  justify-content: center;
}
</style>
